#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <omp.h>

#include "FreqSetter.h"
#include "probe_msr.h"

#define asmLoop()\
{\
   asm volatile(\
      "addl $1,%%eax;\n\t"\
      "addl $1,%%eax;\n\t"\
      "addl $1,%%eax;\n\t"\
      "addl $1,%%eax;\n\t"\
      "addl $1,%%eax;\n\t"\
      "addl $1,%%eax;\n\t"\
      "addl $1,%%eax;\n\t"\
      "addl $1,%%eax;\n\t"\
      :\
      :\
      :"%eax"\
   );\
}

unsigned int cpu_loop (unsigned int n)
{
    unsigned int i;

	for( i = 0; i < n ; i ++ )
		asmLoop();

    return i;
}

void test(unsigned int nCPU, unsigned int iterations )
{
   unsigned int iteration;
	
   for ( iteration = 0; iteration < iterations; iteration ++)
	{
		#pragma omp parallel  default(none) shared(nCPU) 
		{
			cpu_loop(nCPU);
		}
	}
}


